import requests
import csv

outfile = open('beacons.csv','w')
writer = csv.writer(outfile)

meridian_url = "https://edit.meridianapps.com/api/locations/"
location = "<your_location_id>"             # enter your location id
authtoken = "<your_authorization_token>"     # enter your auth token
locations_api = "https://edit.meridianapps.com/api/locations/" + str(location)
beacons_api = locations_api + "/beacons"   # can optionally add ?page_size=1
payload = ""
headers = {
    'Content-Type': "application/x-www-form-urlencoded",
    'Authorization': "Token" + str(authtoken),
    'cache-control': "no-cache"
    }
location_info = requests.get(locations_api, headers=headers)
loc_parsed = location_info.json()
api_call = 1

print("Location Name:", loc_parsed['name'])
print("Here is the Beacon data API:", beacons_api)


def get_beacons():
    global api_call
    print("API GET round #", api_call)
    response = requests.request("GET", beacons_api, data=payload, headers=headers)
    global jparse
    jparse = response.json()
    global beacons_data
    beacons_data = jparse['results']
    api_call += 1
    return


def table_header():
    for beacon in beacons_data:
        header = beacon.keys()
        writer.writerow(header)
        print("Writing Table Headers:", list(header))
        return


def check_for_more():
    # for nextpage of beacons in jparse:
        if str(jparse['next']) != 'None':
            print("Next Page", jparse['next'])
            global beacons_api
            beacons_api = jparse['next']
            get_beacons()
            write_beacons()
        else:
            print("We're done here!")
            exit()


def write_beacons():
    print("Writing Beacon Data")
    for beacon in beacons_data:
        writer.writerow(beacon.values())
    check_for_more()    # check to see if there are more beacons


get_beacons()
# print("Here is the data")
# for beacon in beacons_data:
#     print(format(beacon))
table_header()
write_beacons()
